// the Render methods are all defined in graphcover.cpp
class Line : public DrawElt
{
protected:
  Coord P1[2], P2[2];
  Coord R;
  bool erase;

public:
  Line(Coord inP1[2], Coord inP2[2], Coord inR, Coord inZ, bool inErase=false)
    : DrawElt(inZ), R(inR), erase(inErase)
  { P1[0]=inP1[0];
    P1[1]=inP1[1];
    P2[0]=inP2[0];
    P2[1]=inP2[1];
  }

  void Render(DrawTo *dt);
};

class Disc : public DrawElt
{
protected:
  Coord C[2];
  Coord R;
  bool erase;

public:
  Disc(Coord inC[2], Coord inR, Coord inZ, bool inErase=false)
    : DrawElt(inZ), R(inR), erase(inErase)
  { C[0]=inC[0];
    C[1]=inC[1];
  }

  void Render(DrawTo *dt);
};


class Text : public DrawElt
{
protected:
  Coord ll[2];
  string text;

public:
  Text(Coord inLL[2], Coord inZ, string inText)
    : DrawElt(inZ), text(inText)
  { ll[0]=inLL[0];
    ll[1]=inLL[1];
  }

  void Render(DrawTo *dt);
};
